<script setup>
import ClipLoader from "vue-spinner/src/ClipLoader.vue";

defineProps(["loading"]);
const emit = defineEmits(["search"]);
let timer;

function onChange(evt) {
  const { value } = evt.target;

  clearTimeout(timer);
  if (value.length < 3) return;

  timer = setTimeout(() => {
    emit("search", value);
  }, 800);
}
</script>

<template>
  <div class="search-input">
    <input
      class="search"
      type="text"
      id="username"
      @input="onChange"
      placeholder="Digite um nome"
    />
    <div>
      <ClipLoader size="22px" :loading="loading" />
    </div>
  </div>
</template>

<style lang="scss" scoped>
.search-input {
  border: solid 1px rgb(220, 220, 220);
  border-radius: 30px;
  display: grid;
  grid-template-columns: auto 30px;
  padding: 10px 20px;

  .search {
    border: none;
    font-size: 24px;
    width: 100%;

    &:focus {
      outline: none;
    }
  }
}
</style>
